'Dim SDB
'Set SDB = CreateObject("SongsDB.SDBApplication")

'==========================================================================
'
' NAME: MediaMonkey Last.FM Scrobbler Options Script
'
' AUTHOR: Peke , (c) Ventis Media Inc. 
' DATE  : 23.06.2009
'
'==========================================================================
Sub OnStartup
  SDB.IniFile.IntValue("Last.FM","OptionSheetID") = SDB.UI.AddOptionSheet(SDB.Localize("Last.fm Service"),Script.ScriptPath,"InitSheet","SaveSheet",-3)
  If Not SDB.IniFile.ValueExists("Last.FM","Enabled") Then
    SDB.IniFile.BoolValue("Last.FM","Enabled") = True
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","OnlyWithAlbumTagged") Then
    SDB.IniFile.BoolValue("Last.FM","OnlyWithAlbumTagged") = False
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","NowPlaying") Then
    SDB.IniFile.BoolValue("Last.FM","NowPlaying") = True
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","ForceHandshake") Then
    SDB.IniFile.BoolValue("Last.FM","ForceHandshake") = True
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","Status") Then
    SDB.IniFile.IntValue("Last.FM","Status") = 1
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","EnableToolbarIcon") Then
    SDB.IniFile.BoolValue("Last.FM","EnableToolbarIcon") = True
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","ScrobbleOnlyLibrary") Then
    SDB.IniFile.BoolValue("Last.FM","ScrobbleOnlyLibrary") = True
  End If
  If Not SDB.IniFile.BoolValue("Last.FM","MultipleArtist") Then
    SDB.IniFile.BoolValue("Last.FM","MultipleArtist") = False
  End If

  If Not SDB.IniFile.ValueExists("Last.FM","Filters") Then
    If SDB.VersionHi < 4 Then
      SDB.IniFile.StringValue("Last.FM","Filters") = "1,2"
    Else
      SDB.IniFile.StringValue("Last.FM","Filters") = "3, 4, 6, 7"
    End if
  End If
  If Not SDB.IniFile.ValueExists("Last.FM","LogToFile") Then
    SDB.IniFile.BoolValue("Last.FM","LogToFile") = True
  End If
  SDB.IniFile.IntValue("Last.FM","CacheIcon") = SDB.RegisterIcon("Scripts\Auto\LastfmCache.ico", 0)
  SDB.IniFile.IntValue("Last.FM","EnableIcon") = SDB.RegisterIcon("Scripts\Auto\LastfmOn.ico", 0)
  SDB.IniFile.IntValue("Last.FM","DisableIcon") = SDB.RegisterIcon("Scripts\Auto\LastfmOff.ico", 0)
  Dim LastfmQuickButton
  If SDB.VersionHi < 4 then
    Set LastfmQuickButton = SDB.UI.AddMenuItem(SDB.UI.Menu_TbStandard, 0, 0)   
  Else
    Set LastfmQuickButton = SDB.UI.AddMenuItem(SDB.UI.AddToolbar("Last.FM Scrobbler"), 0, 0) 
  End If  
  SDB.Objects("LastfmQuickButton") = LastfmQuickButton
  LastfmQuickButton.OnClickFunc = "LastfmQuickButtonAction"
  LastfmQuickButton.UseScript = Script.ScriptPath
  LastfmQuickButton.Hint = SDB.Localize("Enable, disable or cache only Last.fm submissions.")
  LastfmQuickButton.Caption = SDB.Localize("Last.fm submission options")

  If SDB.IniFile.IntValue("Last.FM","Status") = 1 Then
    SDB.IniFile.BoolValue("Last.FM","Enabled") = True
    LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","EnableIcon")
  ElseIf SDB.IniFile.IntValue("Last.FM","Status") = 2 Then
    LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","CacheIcon")
    SDB.IniFile.BoolValue("Last.FM","CacheOnly") = True
  ElseIf SDB.IniFile.IntValue("Last.FM","Status") = 3 Then
    LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","DisableIcon")
    SDB.IniFile.BoolValue("Last.FM","Enabled") = False
  End If
  LastfmQuickButton.Visible = SDB.IniFile.BoolValue("Last.FM","EnableToolbarIcon")
  
  'ind = SDB.UI.AddOptionSheet(SDB.Localize("Submission Rules"),Script.ScriptPath,"InitFilterSheet","SaveFilterSheet",SDB.IniFile.IntValue("Last.FM","OptionSheetID"))
  
End Sub

Sub OnShutdown
  SDB.IniFile.IntValue("Last.FM","OptionSheetID") = -3
End Sub

Sub LastfmQuickButtonAction(arg)
  Dim Status
  Status = 3
  If SDB.IniFile.IntValue("Last.FM","Status") = 1 Then
    arg.IconIndex = SDB.IniFile.IntValue("Last.FM","CacheIcon")
    SDB.IniFile.BoolValue("Last.FM","CacheOnly") = True
    Status = 2
  ElseIf SDB.IniFile.IntValue("Last.FM","Status") = 2 Then
    arg.IconIndex = SDB.IniFile.IntValue("Last.FM","DisableIcon")
    SDB.IniFile.BoolValue("Last.FM","Enabled") = False
    SDB.IniFile.BoolValue("Last.FM","CacheOnly") = False
    Status = 3
  ElseIf SDB.IniFile.IntValue("Last.FM","Status") = 3 Then
    SDB.IniFile.BoolValue("Last.FM","Enabled") = True
    SDB.IniFile.BoolValue("Last.FM","CacheOnly") = False
    arg.IconIndex = SDB.IniFile.IntValue("Last.FM","EnableIcon")
    Status = 1
  End If
  SDB.IniFile.IntValue("Last.FM","Status") = Status
End Sub

Sub InitSheet( Sheet)
  Script.Reload(Script.ScriptPath) 'Script Reload on INI Sheet so that updates can be checked

  Set UI = SDB.UI
  Dim LabelAbout : Set LabelAbout = UI.NewLabel(Sheet)
  LabelAbout.Multiline = True
  LabelAbout.Common.SetRect 5,5,470,40
  LabelAbout.Common.Anchors = 4
  LabelAbout.Caption = SDB.Localize("Last.fm can automatically help you find people that have similar musical tastes and creates personalized music recommendations. To learn more visit www.last.fm")
  
  Dim GBoxProfile : Set GBoxProfile = UI.NewGroupBox(Sheet)
  GBoxProfile.Caption = SDB.Localize("Last.fm Profile")
  GBoxProfile.Common.SetRect 5,50,470,80
  GBoxProfile.Common.ControlName = "LastFMProfile"
    
  Dim Label1 : Set Label1 = UI.NewLabel(GBoxProfile)
  Label1.Autosize = True
  Label1.Common.SetRect 10,21,65,40
  Label1.Common.Anchors = 4
  Label1.Caption = SDB.Localize("Username:")
  Label1.Common.Hint = SDB.Localize("Enter your username and password.  If you don't have an account, sign up at www.last.fm")
  
  Dim Edit1 : Set Edit1 = UI.NewEdit(GBoxProfile)
  Edit1.Common.ControlName = "LastFMUsername"
  Edit1.Common.SetRect 100,17,121,20
  Edit1.Text = SDB.IniFile.StringValue("Last.FM","Username")
  Edit1.Common.Anchors = 1
  Edit1.Common.Hint = SDB.Localize("Enter your username and password.  If you don't have an account, sign up at www.last.fm")
  
  Dim Label2 : Set Label2 = UI.NewLabel(GBoxProfile)
  Label2.Autosize = True
  Label2.Common.SetRect 12,53,65,37
  Label2.Caption = SDB.Localize("Password:")
  Label2.Common.Hint = SDB.Localize("Enter your username and password.  If you don't have an account, sign up at www.last.fm")
  
  Dim Edit2 : Set Edit2 = UI.NewEdit(GBoxProfile)
  Edit2.Common.SetRect 100,48,121,21
  Edit2.Text = SDB.IniFile.StringValue("Last.FM","Password")
  Edit2.Common.ControlName = "LastFMPassword"
  Edit2.PasswordChar = "*"
  Edit2.Common.Hint = SDB.Localize("Enter your username and password.  If you don't have an account, sign up at www.last.fm")
  
  Dim GBoxSubmit : Set GBoxSubmit = UI.NewGroupBox(Sheet)
  GBoxSubmit.Caption = SDB.Localize("Last.fm Service")
  GBoxSubmit.Common.SetRect 5,135,470,95
  GBoxSubmit.Common.ControlName = "LastFMService"
  
  'Dim CheckBox0 : Set CheckBox0 = UI.NewCheckBox(GBoxSubmit)
  'CheckBox0.Common.SetRect 10,20,460,20
  'CheckBox0.Common.MaxWidth = 460
  'CheckBox0.Checked = SDB.IniFile.BoolValue("Last.FM","MultipleArtist")
  'CheckBox0.Common.ControlName = "MultipleArtist"
  'CheckBox0.Common.Hint = SDB.Localize("Enabling this will tell plugin to submit Multi-Artist to last.fm instead of just first artist of tracks with Multi-Atrist")
  'CheckBox0.Caption = SDB.Localize("Submit Mutli-Artist to Last.fm")

  Dim CheckBox1 : Set CheckBox1 = UI.NewCheckBox(GBoxSubmit)
  CheckBox1.Common.SetRect 10,20,460,20
  CheckBox1.Common.MaxWidth = 460
  CheckBox1.Checked = SDB.IniFile.BoolValue("Last.FM","Enabled")
  CheckBox1.Common.ControlName = "EnableLastFM"
  CheckBox1.Common.Hint = SDB.Localize("Submits tracks to Last.fm as they play, building your profile so that you can receive music recommendations.")
  CheckBox1.Caption = SDB.Localize("Submit played tracks to build my Last.fm profile and get music recommendations")

  Dim CheckBox3 : Set CheckBox3 = UI.NewCheckBox(GBoxSubmit)
  CheckBox3.Common.SetRect 30,40,440,20
  CheckBox3.Common.MaxWidth = 440
  CheckBox3.Checked = SDB.IniFile.BoolValue("Last.FM","NowPlaying")
  CheckBox3.Common.ControlName = "EnableNowPlaying"
  CheckBox3.Common.Hint = SDB.Localize("Submits information about your Now Playing track to Last.fm so that friends that you have defined on your Friends List can see what you're listening to. This will not affect your profile or playing statistics.")
  CheckBox3.Caption = SDB.Localize("Show Now Playing tracks to my Friends on www.last.fm")
  
  Dim Button1 : Set Button1 = UI.NewButton(GBoxSubmit)
  Button1.Common.SetRect 30,65,100,20
  Button1.Common.MaxWidth = 100
  Button1.Default = False
  Button1.OnClickFunc = "OpenSubmissonRules"
  Button1.UseScript = Script.ScriptPath
  Button1.Common.ControlName = "SubmitRules"
  Button1.Common.Hint = SDB.Localize("Here you can set submission rules for last.fm plugin")
  Button1.Caption = SDB.Localize("Submission Rules")
  
  Dim CheckBox4 : Set CheckBox4 = UI.NewCheckBox(Sheet)
  CheckBox4.Common.SetRect 15,235,460,20
  CheckBox4.Common.MaxWidth = 460
  CheckBox4.Checked = SDB.IniFile.BoolValue("Last.FM","EnableToolbarIcon")
  CheckBox4.Common.ControlName = "EnableToolbarIcon"
  CheckBox4.Common.Hint = SDB.Localize("Show last.fm Toolbar Icon")
  CheckBox4.Caption = SDB.Localize("Show last.fm Toolbar Icon")

  Dim GBoxLog : Set GBoxLog = UI.NewGroupBox(Sheet)
  GBoxLog.Caption = SDB.Localize("Log File (last 5 Entries)")
  GBoxLog.Common.SetRect 5,275,470,120
  GBoxLog.Common.ControlName = "LastFMLog"

  Dim LogLabel1 : Set LogLabel1 = UI.NewLabel(GBoxLog)
  LogLabel1.Autosize = True
  LogLabel1.Common.SetRect 10,21,460,20
  LogLabel1.Common.Anchors = 4
  LogLabel1.Caption = SDB.IniFile.StringValue("Last.FM","Log1")
  LogLabel1.Common.ControlName = "LastFMLog1"

  Dim LogLabel2 : Set LogLabel2 = UI.NewLabel(GBoxLog)
  LogLabel2.Autosize = True
  LogLabel2.Common.SetRect 10,41,460,20
  LogLabel2.Common.Anchors = 4
  LogLabel2.Caption = SDB.IniFile.StringValue("Last.FM","Log2")
  LogLabel2.Common.ControlName = "LastFMLog2"

  Dim LogLabel3 : Set LogLabel3 = UI.NewLabel(GBoxLog)
  LogLabel3.Autosize = True
  LogLabel3.Common.SetRect 10,61,460,20
  LogLabel3.Common.Anchors = 4
  LogLabel3.Caption = SDB.IniFile.StringValue("Last.FM","Log3")
  LogLabel3.Common.ControlName = "LastFMLog3"

  Dim LogLabel4 : Set LogLabel4 = UI.NewLabel(GBoxLog)
  LogLabel4.Autosize = True
  LogLabel4.Common.SetRect 10,81,460,20
  LogLabel4.Common.Anchors = 4
  LogLabel4.Caption = SDB.IniFile.StringValue("Last.FM","Log4")
  LogLabel4.Common.ControlName = "LastFMLog4"

  Dim LogLabel5 : Set LogLabel5 = UI.NewLabel(GBoxLog)
  LogLabel5.Autosize = True
  LogLabel5.Common.SetRect 10,101,460,20
  LogLabel5.Common.Anchors = 4
  LogLabel5.Caption = SDB.IniFile.StringValue("Last.FM","Log5")
  LogLabel5.Common.ControlName = "LastFMLog5"

  'Added Refresh Button As moving sheet out of focus do not Refresh Values
  Dim GRefreshLog : Set GRefreshLog = UI.NewButton(Sheet)
  GRefreshLog.Caption = SDB.Localize("Refresh")
  GRefreshLog.Common.SetRect 415,280,60,20
  GRefreshLog.Common.ControlName = "LastFMRefreshLog"
  GRefreshLog.OnClickFunc = "LastFMRefreshLog"
  GRefreshLog.UseScript = Script.ScriptPath
  
  Dim GShowLog : Set GShowLog = UI.NewButton(Sheet)
  GShowLog.Caption = SDB.Localize("Show Log File")
  GShowLog.Common.SetRect 5,400,120,20
  GShowLog.Common.ControlName = "LastFMShowLog"
  GShowLog.OnClickFunc = "LastFMShowLog"
  GShowLog.UseScript = Script.ScriptPath

  Dim CleanCache : Set CleanCache = UI.NewButton(Sheet)
  CleanCache.Caption = SDB.Localize("Clean Cache")
  CleanCache.Common.SetRect 355,400,120,20
  CleanCache.Common.ControlName = "LastFMCleanCache"
  CleanCache.OnClickFunc = "LastFMCleanCache"
  CleanCache.UseScript = Script.ScriptPath

End Sub

Sub OpenSubmissonRules(btn)
  Set MySubRules = SDB.UI.NewForm
  
  MySubRules.Caption = SDB.Localize("Submission Rules")
  MySubRules.BorderStyle = 3
  MySubRules.SavePositionName = "LastMFSubmissionRulesForm"
  'MySubRules.StayOnTop = True
  MySubRules.Common.ClientWidth = 480
  MySubRules.Common.ClientHeight = 280

  Dim CheckBox2 : Set CheckBox2 = SDB.UI.NewCheckBox(MySubRules)
  CheckBox2.Common.SetRect 15,10,440,20
  CheckBox2.Common.MaxWidth = 440
  CheckBox2.Checked = SDB.IniFile.BoolValue("Last.FM","OnlyWithAlbumTagged")
  CheckBox2.Common.ControlName = "EnableAlbumTagged"
  CheckBox2.Common.Hint = SDB.Localize("Only submits tracks that have an Album name defined.")
  CheckBox2.Caption = SDB.Localize("Only submit tracks if Album metadata exists")
  
  Dim CheckBox1 : Set CheckBox1 = SDB.UI.NewCheckBox(MySubRules)
  CheckBox1.Common.SetRect 15,30,440,20
  CheckBox1.Common.MaxWidth = 440
  CheckBox1.Checked = SDB.IniFile.BoolValue("Last.FM","ScrobbleOnlyLibrary")
  CheckBox1.Common.ControlName = "ScrobbleOnlyLibrary"
  CheckBox1.Common.Hint = SDB.Localize("Only submits tracks that are part of the Library.")
  CheckBox1.Caption = SDB.Localize("Only submit tracks that are part of the Library")

  Set Iter = SDB.Database.OpenSQL( "Select * FROM Filters Order BY ID")
  While Not Iter.EOF
  If Not IsArray(Elements) Then
    redim Elements(1,0)
	End If
	Elements(0,UBound(Elements,2)) = Iter.ValueByName("Name")
	Elements(1,UBound(Elements,2)) = Iter.ValueByName("ID")
	Iter.Next
	If Not Iter.EOF Then
	  redim preserve Elements(UBound (Elements,1), UBound(Elements,2) + 1)
	End If
  Wend
  Set Iter = Nothing

  Dim Gbox1 : Set Gbox1 = SDB.UI.NewGroupBox(MySubRules)
  Gbox1.Common.SetRect 10,60,460,180
  Gbox1.Common.Anchors = 4
  Gbox1.Caption = SDB.Localize("Exclude tracks that match the following filters:")

  Set newtree = SDB.UI.NewTreeList(Gbox1)
  newtree.Common.SetRect 10, 22, 440, 150
  newtree.FullRowSelect = False
  newtree.MultiSelect = False
  newtree.ShowTreeLines = False
  newtree.ShowRoot = False
  newtree.Common.ControlName = "filtersel"
  Script.RegisterEvent newtree, "OnGetText", "GetTreeName"

  For i = 0 To (UBound(Elements,2))
    Set testnode = newtree.AddNode(Nothing)
    testnode.HasChildren = false
    testnode.CheckType = 2
    testnode.CheckState = CheckFilterSelected(Elements(1,i))
  Next

  Dim Button1 : Set Button1 = SDB.UI.NewButton(MySubRules)
  Button1.Common.SetRect 320,250,70,20
  Button1.Common.MaxWidth = 100
  Button1.Default = True
  Button1.ModalResult = 1
  Button1.Common.ControlName = "SaveRules"
  Button1.Caption = SDB.Localize("OK")
  
  Dim Button2 : Set Button2 = SDB.UI.NewButton(MySubRules)
  Button2.Common.SetRect 400,250,70,20
  Button2.Common.MaxWidth = 100
  Button2.Cancel = True
  Button2.ModalResult = -1
  Button2.Common.ControlName = "CancelRules"
  Button2.Caption = SDB.Localize("Cancel")

  If MySubRules.ShowModal = 1 Then
    SDB.IniFile.BoolValue("Last.FM","ScrobbleOnlyLibrary") = MySubRules.Common.ChildControl( "ScrobbleOnlyLibrary").Checked
    SDB.IniFile.BoolValue("Last.FM","OnlyWithAlbumTagged") = MySubRules.Common.ChildControl( "EnableAlbumTagged").Checked
' PETR: don't know why it's here (again, because first time it was filled above at the beginning), but it's causing issue in #5265    
'    Set Iter = SDB.Database.OpenSQL( "Select * FROM Filters Order BY ID")
'    While Not Iter.EOF
'      If Not IsArray(Elements) Then
'        redim Elements(1,0)
'      End If
'      Elements(0,UBound(Elements,2)) = Iter.ValueByName("Name")
'      Elements(1,UBound(Elements,2)) = Iter.ValueByName("ID")
'      Iter.Next
'      If Not Iter.EOF then
'        redim preserve Elements(UBound (Elements,1), UBound(Elements,2) + 1)
'      End If
'    Wend
'    Set Iter = Nothing

    Dim FilterIndex, MyFilters
    MyFilters = ""
    If (MySubRules.Common.ChildControl("filtersel").RootNodeCount > 0) Then
      For i = 1 To (MySubRules.Common.ChildControl("filtersel").RootNodeCount)
        If i = 1 Then 
          Set FilterIndex = MySubRules.Common.ChildControl("filtersel").FirstNode
        Else
          Set FilterIndex = FilterIndex.NextNode
        End If
    
        If (FilterIndex.CheckState = 1) Then
          If MyFilters = "" Then
            MyFilters = MyFilters & (Elements(1,FilterIndex.Index))
          Else
            MyFilters = MyFilters  & "," & (Elements(1,FilterIndex.Index))
          End If
        End If
      Next
    End If
    SDB.IniFile.StringValue("Last.FM","Filters") = MyFilters
  End If
  Script.UnRegisterHandler "GetTreeName"
 
End Sub

Sub SaveSheet(Sheet)
  If not (SDB.IniFile.StringValue("Last.FM","Username") = Sheet.Common.ChildControl( "LastFMUsername").Text) Then
    SDB.IniFile.StringValue("Last.FM","Username") = Sheet.Common.ChildControl( "LastFMUsername").Text
    SDB.IniFile.BoolValue("Last.FM","ForceHandshake") = True
  End if
  SDB.IniFile.StringValue("Last.FM","Password") = Sheet.Common.ChildControl( "LastFMPassword").Text
  SDB.IniFile.BoolValue("Last.FM","Enabled") = Sheet.Common.ChildControl( "EnableLastFM").Checked
  SDB.IniFile.BoolValue("Last.FM","NowPlaying") = Sheet.Common.ChildControl( "EnableNowPlaying").Checked
  'SDB.IniFile.BoolValue("Last.FM","MultipleArtist") = Sheet.Common.ChildControl( "MultipleArtist").Checked
  Dim LastfmQuickButton
  Set LastfmQuickButton = SDB.Objects("LastfmQuickButton")
  LastfmQuickButton.Visible = (Sheet.Common.ChildControl( "EnableToolbaricon").Checked)
  If (Sheet.Common.ChildControl( "EnableLastFM").Checked) Then
    If SDB.IniFile.BoolValue("Last.FM","CacheOnly") Then
      SDB.IniFile.IntValue("Last.FM","Status") = 2
      LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","CacheIcon")
    Else
      SDB.IniFile.BoolValue("Last.FM","CacheOnly") = False
      SDB.IniFile.IntValue("Last.FM","Status") = 1
      LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","EnableIcon")
    End If
  Else
    SDB.IniFile.IntValue("Last.FM","Status") = 3
    LastfmQuickButton.IconIndex = SDB.IniFile.IntValue("Last.FM","DisableIcon")
  End If
  SDB.IniFile.BoolValue("Last.FM","EnableToolbarIcon") = LastfmQuickButton.Visible
  SDB.Objects("LastfmQuickButton") = LastfmQuickButton
End Sub

Sub LastFMShowLog(Btn)
If not SDB.IniFile.BoolValue("Last.FM","LogToFile") Then Exit Sub
Dim WShell, Command, Result
Set WShell = CreateObject("WScript.Shell")
Command = Chr(34)&SDB.IniFile.StringValue("Last.FM","Path")&"LastFM_Log.txt"&CHR(34)&CHR(34)
WShell.Run Command
set WShell = Nothing
End Sub

Sub LastFMCleanCache(Btn)
SDB.Tools.FileSystem.DeleteFile(SDB.IniFile.StringValue("Last.FM","Path")&"LastFM_Cache.dat")
End Sub


Sub LastFMRefreshLog(Btn)
  Btn.Common.Parent.Common.ChildControl( "LastFMLog1").Caption = SDB.IniFile.StringValue("Last.FM","Log1")
  Btn.Common.Parent.Common.ChildControl( "LastFMLog2").Caption = SDB.IniFile.StringValue("Last.FM","Log2")
  Btn.Common.Parent.Common.ChildControl( "LastFMLog3").Caption = SDB.IniFile.StringValue("Last.FM","Log3")
  Btn.Common.Parent.Common.ChildControl( "LastFMLog4").Caption = SDB.IniFile.StringValue("Last.FM","Log4")
  Btn.Common.Parent.Common.ChildControl( "LastFMLog5").Caption = SDB.IniFile.StringValue("Last.FM","Log5")
End Sub

Function CheckFilterSelected(FilterID)
  Dim myFiltersSel, FilterArray, filtered
  filtered = 0
  myFiltersSel = SDB.IniFile.StringValue("Last.FM","Filters")
  FilterArray = Split(myFiltersSel,",",-1)
  If IsEmpty(FilterArray) Then
    filtered = 0
  Else
	For Each s In FilterArray
	  If (filtered = 0) And (cstr(FilterID) = Trim(s)) Then
	    filtered = 1
	  End If
	Next
  End If 
  CheckFilterSelected = filtered
End Function

Function GetTreeName(treenode, columnid)
  If InEventHandler Then Exit Function
  Set Iter = SDB.Database.OpenSQL( "Select * FROM Filters Order BY ID")
  While Not Iter.EOF
  If Not IsArray(Elements) Then
    redim Elements(1,0)
	End If
	Elements(0,UBound(Elements,2)) = Iter.ValueByName("Name")
	Elements(1,UBound(Elements,2)) = Iter.ValueByName("ID")
	Iter.Next
	If Not Iter.EOF Then
	  redim preserve Elements(UBound (Elements,1), UBound(Elements,2) + 1)
	End If
  Wend
  Set Iter = Nothing
  GetTreeName = Elements(0,treenode.index)
End Function

Sub SetupRules
  Dim btn
  OpenSubmissonRules(btn)
End Sub